/*
 *  $Id$
 * 
 *   Badger - Threaded Behavior Protocols analysis toolchain
 *   Copyright (C) 2011       DSRG, Charles University in Prague
 *                            http://dsrg.mff.cuni.cz/
 * 
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 * 
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 * 
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *   MA 02110-1301 USA
 * 
 */
package org.ow2.dsrg.fm.badger.ca.karpmiller.impl;

import java.util.Iterator;

/**
 * @author Ondrej Cerny &lt;ondrej.cerny@email.cz&gt;
 */
public class ConfigurationsIterable<NAME, VAL> implements Iterable<org.ow2.dsrg.fm.badger.ca.karpmiller.Configuration<NAME, VAL>> {
	
	private class ConfigurationsIterator implements Iterator<org.ow2.dsrg.fm.badger.ca.karpmiller.Configuration<NAME, VAL>> {

		private org.ow2.dsrg.fm.badger.ca.karpmiller.ConfigurationNode<NAME, VAL> node;
		
		protected ConfigurationsIterator(org.ow2.dsrg.fm.badger.ca.karpmiller.ConfigurationNode<NAME, VAL> node) {
			this.node = node;
		}
		@Override
		public boolean hasNext() {
			return this.node != null;
		}

		@Override
		public org.ow2.dsrg.fm.badger.ca.karpmiller.Configuration<NAME, VAL> next() {
			org.ow2.dsrg.fm.badger.ca.karpmiller.Configuration<NAME, VAL> tmp =
				this.node.getConfiguration();
			this.node = this.node.getPredecessor();
			return tmp;
		}

		@Override
		public void remove() {
			throw new UnsupportedOperationException("Remove operation is not supported within predecessors iterable.");
		}		
	}
	
	private org.ow2.dsrg.fm.badger.ca.karpmiller.ConfigurationNode<NAME, VAL> node;
	
	public ConfigurationsIterable(org.ow2.dsrg.fm.badger.ca.karpmiller.ConfigurationNode<NAME, VAL> node) {
		this.node = node;
	}

	@Override
	public Iterator<org.ow2.dsrg.fm.badger.ca.karpmiller.Configuration<NAME, VAL>> iterator() {
		return new ConfigurationsIterator(this.node);
	}

}
