/*
 *  $Id$
 * 
 *   Badger - Threaded Behavior Protocols analysis toolchain
 *   Copyright (C)      2011  DSRG, Charles University in Prague
 *                            http://dsrg.mff.cuni.cz/
 * 
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 * 
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 * 
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *   MA 02110-1301 USA
 * 
 */
package org.ow2.dsrg.fm.badger.ca.karpmiller.opt;

import org.ow2.dsrg.fm.badger.ca.karpmiller.Configuration;

/** Represents closure of covers relation.
 * 
 * @author Ondrej Cerny &lt;ondrej.cerny@email.cz&gt;
 */
public class MinimalCover<NAME, VAL> 
extends MinimalClosure<Configuration<NAME, VAL>>
implements Cover<Configuration<NAME, VAL>> {
	
	public MinimalCover() {
		super(new PartialOrder<Configuration<NAME, VAL>>() {
			@Override
			public boolean inOrder(Configuration<NAME, VAL> a,
					Configuration<NAME, VAL> b) {
				// return true if and only if a -> b
				return a.covers(b);
			}
		});
	}
}