/*
 *  $Id$
 * 
 *   Badger - Threaded Behavior Protocols analysis toolchain
 *   Copyright (C)      2011  DSRG, Charles University in Prague
 *                            http://dsrg.mff.cuni.cz/
 * 
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 * 
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 * 
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *   MA 02110-1301 USA
 * 
 */
package org.ow2.dsrg.fm.badger.ca.karpmiller.opt;

import java.util.HashSet;
import java.util.Set;

import org.ow2.dsrg.fm.badger.ca.karpmiller.Configuration;

/**
 * @author Ondrej Cerny &lt;ondrej.cerny@email.cz&gt;
 */
public class NaiveCover<NAME, VAL> implements Cover<Configuration<NAME, VAL>>{
	
	private Set<Configuration<NAME, VAL>> cs = new HashSet<Configuration<NAME,VAL>>(); 

	@Override
	public Configuration<NAME, VAL> add(Configuration<NAME, VAL> e) {
		Configuration<NAME, VAL> x = null;
		if (cs.add(e) == false) {
			x = e;
		}
		return x;
	}

}
