/*
 *  $Id$
 * 
 *   Badger - Threaded Behavior Protocols analysis toolchain
 *   Copyright (C) 2008-2010  DSRG, Charles University in Prague
 *                            http://dsrg.mff.cuni.cz/
 * 
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 * 
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 * 
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *   MA 02110-1301 USA
 * 
 */
package org.ow2.dsrg.fm.badger.ca.statespace;

import java.util.Map;

import org.ow2.dsrg.fm.tbplib.reference.StateVariable;

/** Represents <i>global state</i> i.e. valuation of global variables.
 * 
 * <p>Note that in context of reference to the original TBP specification,
 *    the global variable is mainly represented by {@link StateVariable}.</p> 
 * 
 * @author Ondrej Cerny &lt;ondrej.cerny@email.cz&gt;
 */
public interface GlobalState<NAME, VAL> extends VariableValuation<NAME, VAL> {
	/** Returns {@link GlobalState} with modified values of variables.
	 * 
	 * @param newVariableValues variable values modifications
	 * @return {@link GlobalState} with modified values of variables
	 */
	public GlobalState<NAME, VAL> modify(Map<NAME, VAL> newVariableValues);
}
