/*
 *  $Id$
 * 
 *   Badger - Threaded Behavior Protocols analysis toolchain
 *   Copyright (C) 2010       DSRG, Charles University in Prague
 *                            http://dsrg.mff.cuni.cz/
 * 
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 * 
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 * 
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *   MA 02110-1301 USA
 * 
 */
package org.ow2.dsrg.fm.badger.ca.statespace.encoding.impl;

import java.util.Collection;

import org.ow2.dsrg.fm.badger.ca.statespace.encoding.LocalStateEncoder;
import org.ow2.dsrg.fm.badger.ca.statespace.encoding.LocalStateEncoderFactory;

/** Creates single {@link PlainLocalStateEncoderImpl} as encoder for all local state <i>classes</i>.
 * 
 * <p>The <i>class</i> of local state stands for all local states that
 *    evaluate same set of local variables.</p>
 * 
 * @author Ondrej Cerny &lt;ondrej.cerny@email.cz&gt;
 */
public class PlainLocalStateEncoderFactoryImpl<NAME, VALUE> implements
		LocalStateEncoderFactory<NAME, VALUE> {
	
	private PlainLocalStateEncoderImpl<NAME, VALUE> encoder;
	
	public PlainLocalStateEncoderFactoryImpl() {
		this.encoder = new PlainLocalStateEncoderImpl<NAME, VALUE>();
	}
	@Override
	public LocalStateEncoder<NAME, VALUE> create(Collection<NAME> localVariables) {
		return encoder;
	}
}
