/*
 *  $Id$
 * 
 *   Badger - Threaded Behavior Protocols analysis toolchain
 *   Copyright (C) 2010       DSRG, Charles University in Prague
 *                            http://dsrg.mff.cuni.cz/
 * 
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 * 
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 * 
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *   MA 02110-1301 USA
 * 
 */
package org.ow2.dsrg.fm.badger.ca.statespace.encoding.impl;

import org.ow2.dsrg.fm.badger.ca.statespace.LocalState;
import org.ow2.dsrg.fm.badger.ca.statespace.encoding.LocalStateCode;
import org.ow2.dsrg.fm.badger.ca.statespace.encoding.LocalStateEncoder;

/** Simple encoder that uses the state itself as its code. 
 * 
 * @author Ondrej Cerny &lt;ondrej.cerny@email.cz&gt;
 */
public class PlainLocalStateEncoderImpl<NAME, VALUE> implements LocalStateEncoder<NAME, VALUE> {

	@Override
	public LocalStateCode encodeState(LocalState<NAME, VALUE> s) {
		return (LocalStateCode)s;
	}

	@SuppressWarnings("unchecked")
	@Override
	public LocalState<NAME, VALUE> decodeLocalState(LocalStateCode s) {
		return (LocalState<NAME, VALUE>)s;
	}
}
