/*
 *  $Id$
 * 
 *   Badger - Threaded Behavior Protocols analysis toolchain
 *   Copyright (C) 2008-2010  DSRG, Charles University in Prague
 *                            http://dsrg.mff.cuni.cz/
 * 
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 * 
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 * 
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *   MA 02110-1301 USA
 * 
 */
package org.ow2.dsrg.fm.badger.ca.statespace.impl;

import java.util.Map;

import org.ow2.dsrg.fm.badger.ca.statespace.GlobalState;

/**
 * @author Ondrej Cerny &lt;ondrej.cerny@email.cz&gt;
 */
public class GlobalStateImpl<NAME, VAL>
	extends VariableValuationImpl<NAME, VAL>
	implements GlobalState<NAME, VAL> {
	
	public GlobalStateImpl() {
		this(null);
		this.finishInitialization();
	}
	
	protected GlobalStateImpl(Map<NAME, VAL> variableValues) {
		super(variableValues);
	}

	@Override
	public GlobalState<NAME, VAL> modify(Map<NAME, VAL> newVariableValues) {
		GlobalStateImpl<NAME, VAL> modified = new GlobalStateImpl<NAME, VAL>(this.vars);
		modified.addVariableValuesMapping(newVariableValues);
		modified.finishInitialization();
		return modified;
	}
	
	@Override
	public int hashCode() {
		return super.hashCode();
	}
	
	@Override
	public boolean equals(Object o) {
		if (o == this) {
			return true;
		} else if (o != null && o instanceof GlobalState<?, ?>) {
			return super.equals(o);
		} else {
			return false;
		}
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		appendAsString(sb, ", ", false);
		return sb.toString();
	}	
}
