package org.ow2.dsrg.fm.badger.ca.stats.util;

import org.ow2.dsrg.fm.badger.ca.stats.ValueHandler;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

public abstract class AbstractValueHandler implements ValueHandler {
	
	private String name; 
	
	public AbstractValueHandler(String name) {
		this.name = name;
		assert(name != null);
	}

	@Override
	public String getName() {
		return this.name;
	}
	
	@Override
	public void appendTo(Document d, Node n) {
		Element e = d.createElement("value");
		e.setAttribute("name", getName());
		e.setAttribute("type", this.getClass().getName());
		n.appendChild(e);
		this.appendValueTo(d, e);
	}
	
	protected abstract void appendValueTo(Document d, Element e);
}
