/*
 *  $Id$
 * 
 *   Badger - Threaded Behavior Protocols analysis toolchain
 *   Copyright (C) 2008-2010  DSRG, Charles University in Prague
 *                            http://dsrg.mff.cuni.cz/
 * 
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 * 
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 * 
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *   MA 02110-1301 USA
 * 
 */
package org.ow2.dsrg.fm.badger.ca.util;

/** Retains pair of objects.
 * 
 * @author Ondrej Cerny &lt;ondrej.cerny@email.cz&gt;
 * @param <T> type of <i>first</i> object
 * @param <U> type of <i>second</i> object
 */
public class Pair<T, U> {
	private T t;
	private U u;
	/** Constructs a pair (<b>t</b>, <b>u</b>).
	 * 
	 * @param t first element of pair
	 * @param u second element of pair
	 */
	public Pair(T t, U u) {
		this.t = t;
		this.u = u;
	}
	/** Returns first element of this pair.
	 * 
	 * @return first element of this pair
	 */
	public T getFirst() {
		return t;
	}
	/** Returns second element of this pair.
	 * 
	 * @return second element of this pair
	 */	
	public U getSecond() {
		return u;
	}
}