package org.ow2.dsrg.fm.badger.translation;

import org.ow2.dsrg.fm.badger.reference.TranslationReference;
import org.ow2.dsrg.fm.tbplib.node.guard.*;
import org.ow2.dsrg.fm.tbplib.node.visitor.ConditionVisitor;
import org.ow2.dsrg.fm.tbplib.util.CodeWriter;

import java.util.Set;

/**
 * Created by IntelliJ IDEA.
 * User: tom
 * Date: 19.7.2010
 * Time: 11:20:40
 * To change this template use File | Settings | File Templates.
 */
public class ConditionEncodingVisitor implements ConditionVisitor<Void, TranslationReference> {
    private CodeWriter output;

    public ConditionEncodingVisitor(CodeWriter cwr) {
        this.output = cwr;
    }

    private void listSet(TranslationReference left, String operator, String equal, Set<TranslationReference> s) {
        boolean first = true;
        /*output.print("{byte tmpVar = ");

        output.println(";");*/

        //output.print("return ");
        output.increaseIndent();
        for (TranslationReference ref : s) {
            if (first) {
                first = false;
            } else {
                output.println(operator);
            }
            left.writeReadValue(output);
            output.print(equal);
            ref.writeReadValue(output);
        }
        output.decreaseIndent();
        /*output.println(';');
        output.println("}");*/
    }


    @Override
    public Void visitTBPInSet(TBPInSet<TranslationReference> node) {

        TranslationReference left = node.getLeft();
        listSet(left," ||"," == ",node.getSet());

        return null;
    }

    @Override
    public Void visitTBPNotInSet(TBPNotInSet<TranslationReference> node) {

        TranslationReference left = node.getLeft();
        listSet(left," &&"," != ",node.getSet());

        return null;
    }

    @Override
    public Void visitTBPEquals(TBPEquals<TranslationReference> node) {

        node.getLeft().writeReadValue(output);
        output.print(" == ");
        node.getRight().writeReadValue(output);

        return null;
    }

    @Override
    public Void visitTBPNotEquals(TBPNotEquals<TranslationReference> node) {

        node.getLeft().writeReadValue(output);
        output.print(" != ");
        node.getRight().writeReadValue(output);

        return null;
    }

    @Override
    public Void visitTBPNondetCondition(TBPNondetCondition<TranslationReference> node) {
        output.println("true");
        return null;
    }

    @Override
    public Void visitTBPNot(TBPNot<TranslationReference> node) {
        output.print("!(");
        node.getOperand().visit(this);
        output.print(")");
        return null;
    }

    @Override
    public Void visitTBPAnd(TBPAnd<TranslationReference> node) {
        output.print("(");
        node.getLeft().visit(this);
        output.println(") && (");
        node.getRight().visit(this);
        output.print(")");
        return null;
    }

    @Override
    public Void visitTBPOr(TBPOr<TranslationReference> node) {
        output.print("(");
        node.getLeft().visit(this);
        output.println(") || (");
        node.getRight().visit(this);
        output.print(")");
        return null;
    }

}