package org.ow2.dsrg.fm.tbplib.ltsa;

import org.ow2.dsrg.fm.tbplib.ltsa.visitor.LTSVisitor;
import org.ow2.dsrg.fm.tbplib.node.TBPMethodDeclaration;

/**
 * LTS transition labeled with method declaration. 
 * @author David Hauzar
 *
 */
public class LTSMethod<REFERENCE> extends LTSImpl<TBPMethodDeclaration<REFERENCE>, REFERENCE> {
	/** Instances of this class are created via class LTSImpl.*/
	LTSMethod(TBPMethodDeclaration<REFERENCE> tbpMethod) {
		super(tbpMethod, null);
	}
	
	public <RESULT> RESULT visit(LTSVisitor<RESULT, REFERENCE> visitor) {
		return visitor.visitMethodDeclaration(this);
	}
}
