package org.ow2.dsrg.fm.tbplib.ltsa.visitor;

import org.ow2.dsrg.fm.tbplib.ltsa.LTS;
import org.ow2.dsrg.fm.tbplib.ltsa.LTSMethod;
import org.ow2.dsrg.fm.tbplib.ltsa.LTSThread;
import org.ow2.dsrg.fm.tbplib.node.TBPNode;

public interface LTSVisitor<RESULT, REFERENCE> {
	/**
	 * Visits LTS transition.
	 * @param lts the lts node to be visited.
	 */
	<T extends TBPNode<REFERENCE>> RESULT visit(LTS<T, REFERENCE> lts);
	/**
	 * Visit LTS transition that represents thread of TBP protocol.
	 * @param ltsThread the lts node that represents thread.
	 */
	RESULT visitThread(LTSThread<REFERENCE> ltsThread);
	/**
	 * Visit LTS transition that represents thread of TBP protocol.
	 * @param ltsMethod the lts node that represents thread.
	 */
	RESULT visitMethodDeclaration(LTSMethod<REFERENCE> ltsMethod);
}
