/*
 *
 * Threaded Behavior Protocols  - Parsers, Transformations
 * Copyright (C) 2008   DSRG, Charles University in Prague
 *                      http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */
package org.ow2.dsrg.fm.tbplib.node;

import org.ow2.dsrg.fm.tbplib.reference.MethodCall;
import org.ow2.dsrg.fm.tbplib.node.visitor.TBPVisitor;

/**
 * @author caitt3am
 *
 */
public class TBPAccept<REFERENCE> extends TBPProvisionLeafNode<REFERENCE> {

	private final MethodCall<REFERENCE> method;
	private final REFERENCE return_value;
	
	public TBPAccept(MethodCall<REFERENCE> mc, REFERENCE return_value) {
		this.method = mc;
		this.return_value = return_value;		
	}
	
	@Override
	public <RESULT> RESULT visit(TBPVisitor<RESULT, REFERENCE> visitor) {
		return visitor.visitParsedAccept(this);
	}
	
	public MethodCall<REFERENCE> getMethodCall() {
		return method;
	}
	
	public REFERENCE getInterface(){
		return method.getInterface();
	}
	
	public REFERENCE getMethod(){
		return method.getMethod();
	}
	
	public REFERENCE getReturnValue() {
		return return_value;
	}
	
	public String getFullname(){
		return method.getFullname();
	}
	
	public void setInterface(REFERENCE ifaceName){
		method.setInterface(ifaceName);
	}
	
	public void setMethod(REFERENCE methodName){
		method.setMethod(methodName);
	}
}
