package org.ow2.dsrg.fm.tbplib.node;

import java.util.List;

/**
 * Represents unary node with definition of local variables. 
 *  
 * @author hauzd4am
 *
 */
public abstract class TBPImperativeUnaryNodeWithVarDefinition<REFERENCE> extends TBPImperativeUnaryNode<REFERENCE> {
	public TBPImperativeUnaryNodeWithVarDefinition(TBPImperativeNode<REFERENCE> child, 
			List<TBPVariableDefinition<REFERENCE>> varDefs) {
		super(child);
		this.varDefs = varDefs;
	}
	
	/**
	 * Gets local variables defined in this node.
	 * @return local variables defined in this node.
	 */
	public List<TBPVariableDefinition<REFERENCE>> getLocalVariables() {
		return varDefs;
	}
	
	/** Definition of local variables. */
	private List<TBPVariableDefinition<REFERENCE>> varDefs;
}
