package org.ow2.dsrg.fm.tbplib.node.guard;

/**
 * Created by IntelliJ IDEA.
 * User: tom
 * Date: 19.7.2010
 * Time: 11:37:54
 * To change this template use File | Settings | File Templates.
 */
public abstract class TBPBinaryCondition<REFERENCE>  extends TBPConditionImpl<REFERENCE> {

    protected TBPBinaryCondition(ITBPCondition<REFERENCE> left, ITBPCondition<REFERENCE> right) {
        this.left = left;
        this.right = right;
    }

    protected ITBPCondition<REFERENCE> left;
    protected ITBPCondition<REFERENCE> right;

    public ITBPCondition<REFERENCE> getLeft() {
        return left;
    }

    public ITBPCondition<REFERENCE> getRight() {
        return right;
    }

    @Override
    public ITBPCondition<REFERENCE> createNegation() {
        return new TBPNot<REFERENCE>(this);
    }

        @Override
    public TBPBinaryCondition<REFERENCE> clone() {
        TBPBinaryCondition<REFERENCE> ret =  (TBPBinaryCondition<REFERENCE>) super.clone();
        ret.left = left.clone();
        ret.right = right.clone();
        return ret;
    }

    public boolean equals(Object obj) {
        if (obj instanceof TBPBinaryCondition) {
            TBPBinaryCondition cond = (TBPBinaryCondition) obj;
            return ((left == null && cond.left == null) || left.equals(cond.left)) &&
                   ((right == null && cond.right == null) || right.equals(cond.right));
        }
        return false;
    }


    @Override
    protected int recomputeHashCode() {
        return (precomputedHashCode = (left.hashCode()*prime+right.hashCode())*prime); 
    }
}