/*
 *
 * Threaded Behavior Protocols  - Parsers, Transformations
 * Copyright (C) 2008   DSRG, Charles University in Prague
 *                      http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */
package org.ow2.dsrg.fm.tbplib.node.guard;

/**
 * Condition is either '?' (represented by null in both right and left) or a comparison.
 * @author caitt3am
 *
 */
public abstract class TBPBinaryScalarCondition<REFERENCE> extends TBPElementaryCondition<REFERENCE>  {

    public TBPBinaryScalarCondition(REFERENCE left, REFERENCE right) {
        super(left);
        this.right = right;
        recomputeHashCode();
    }

    protected REFERENCE right;

    public REFERENCE getRight() {
            return right;
        }
    


    @Override
    public boolean equals(Object obj) {
        if (obj instanceof TBPBinaryScalarCondition) {
            TBPBinaryScalarCondition cond = (TBPBinaryScalarCondition) obj;

            return  super.equals(obj) &&
                    ((right == null && cond.right == null) || right.equals(cond.right)) ;
        }
        return false;
    }

    protected int recomputeHashCode() {

        int result = super.recomputeHashCode();
        result += right == null ? 0 : right.hashCode();
        result *= prime;

        return precomputedHashCode = result;
    }

    
}