/*
 *
 * Threaded Behavior Protocols  - Parsers, Transformations
 * Copyright (C) 2008   DSRG, Charles University in Prague
 *                      http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */
package org.ow2.dsrg.fm.tbplib.node.guard;

/**
 * Condition is either '?' (represented by null in both right and left) or a comparison.
 * @author caitt3am
 *
 */
public abstract class TBPElementaryCondition<REFERENCE> extends TBPConditionImpl<REFERENCE>  {

	protected REFERENCE left;

    public REFERENCE getLeft() {
        return left;
    }

    public TBPElementaryCondition(REFERENCE left) {
		this.left = left;
        recomputeHashCode();
	}


    @Override
    public boolean equals(Object obj) {
        if (obj instanceof TBPConditionImpl) {
            TBPElementaryCondition cond = (TBPElementaryCondition) obj;
            return ((left == null && cond.left == null) || left.equals(cond.left)); 
        }
        return false;
    }


    @Override
    protected int recomputeHashCode() {
        int result;

        result = left == null ? 0 : left.hashCode();
        result *= prime;

        return precomputedHashCode = result;
    }

}