/*
 *
 * Threaded Behavior Protocols  - Parsers, Transformations
 * Copyright (C) 2008   DSRG, Charles University in Prague
 *                      http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */
package org.ow2.dsrg.fm.tbplib.node.visitor;

import org.ow2.dsrg.fm.tbplib.node.*;

/**
 * Visitor that throws exception on every node.
 * Extend this to check for omitted cases.
 * 
 * @author caitt3am
 *
 */
public class TBPCheckingVisitor<RESULT, REFERENCE> implements TBPVisitor<RESULT, REFERENCE> {

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitLimitedReentrancy(org.ow2.dsrg.fm.tbplib.parsed.TBPLimitedReentrancy)
	 */
	@Override
	public RESULT visitLimitedReentrancy(TBPLimitedReentrancy<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitVariableDefinition(org.ow2.dsrg.fm.tbplib.parsed.TBPVariableDefinition)
	 */
	@Override
	public RESULT visitVariableDefinition(TBPVariableDefinition<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedAlternative(org.ow2.dsrg.fm.tbplib.parsed.TBPAlternative)
	 */
	@Override
	public RESULT visitParsedAlternative(TBPAlternative<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedAssignment(org.ow2.dsrg.fm.tbplib.parsed.TBPAssignment)
	 */
	@Override
	public RESULT visitParsedAssignment(TBPAssignment<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedIf(org.ow2.dsrg.fm.tbplib.parsed.TBPIf)
	 */
	@Override
	public RESULT visitParsedIf(TBPIf<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedImperativeMethodCall(org.ow2.dsrg.fm.tbplib.parsed.TBPParsedImperativeMethodCall)
	 */
	@Override
	public RESULT visitParsedEmit(
			TBPEmit<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedImperativeNull(org.ow2.dsrg.fm.tbplib.parsed.TBPImperativeNull)
	 */
	@Override
	public RESULT visitParsedImperativeNull(TBPImperativeNull<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedImperativeSequence(org.ow2.dsrg.fm.tbplib.parsed.TBPImperativeSequence)
	 */
	@Override
	public RESULT visitParsedImperativeSequence(TBPImperativeSequence<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedMethodDeclaration(org.ow2.dsrg.fm.tbplib.parsed.TBPMethodDeclaration)
	 */
	@Override
	public RESULT visitParsedMethodDeclaration(TBPMethodDeclaration<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedNull(org.ow2.dsrg.fm.tbplib.parsed.TBPProvisionNull)
	 */
	@Override
	public RESULT visitParsedNull(TBPProvisionNull<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedParallel(org.ow2.dsrg.fm.tbplib.parsed.TBPParallel)
	 */
	@Override
	public RESULT visitParsedParallel(TBPParallel<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedParallelOr(org.ow2.dsrg.fm.tbplib.parsed.TBPParallelOr)
	 */
	@Override
	public RESULT visitParsedParallelOr(TBPParallelOr<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedProvisionContainerNode(org.ow2.dsrg.fm.tbplib.parsed.TBPProvisionContainerNode)
	 */
	@Override
	public RESULT visitParsedProvisionContainerNode(
			TBPProvisionContainerNode<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedProvisionMethodCall(org.ow2.dsrg.fm.tbplib.parsed.TBPParsedProvisionMethodCall)
	 */
	@Override
	public RESULT visitParsedAccept(
			TBPAccept<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedRepetition(org.ow2.dsrg.fm.tbplib.parsed.TBPRepetition)
	 */
	@Override
	public RESULT visitParsedRepetition(TBPRepetition<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedthrow(org.ow2.dsrg.fm.tbplib.parsed.TBPParsedthrow)
	 */
	@Override
	public RESULT visitParsedReturn(TBPReturn<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedSequence(org.ow2.dsrg.fm.tbplib.parsed.TBPSequence)
	 */
	@Override
	public RESULT visitParsedSequence(TBPSequence<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedSwitch(org.ow2.dsrg.fm.tbplib.parsed.TBPSwitch)
	 */
	@Override
	public RESULT visitParsedSwitch(TBPSwitch<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedSync(org.ow2.dsrg.fm.tbplib.parsed.TBPSync)
	 */
	@Override
	public RESULT visitParsedSync(TBPSync<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

        @Override
	public RESULT visitParsedWait(TBPWait<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}
        
        
	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedValue(org.ow2.dsrg.fm.tbplib.parsed.TBPValue)
	 */
	@Override
	public RESULT visitParsedValue(TBPValue<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitParsedWhile(org.ow2.dsrg.fm.tbplib.parsed.TBPWhile)
	 */
	@Override
	public RESULT visitParsedWhile(TBPWhile<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
		
	}

	/* (non-Javadoc)
	 * @see org.ow2.dsrg.fm.tbplib.parsed.TBPParsedVisitor#visitUnlimitedReentrancy(org.ow2.dsrg.fm.tbplib.parsed.TBPUnlimitedReentrancy)
	 */
	@Override
	public RESULT visitUnlimitedReentrancy(TBPUnlimitedReentrancy<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());		
	}

	@Override
	public RESULT visitParsedThreadContainerNode(TBPThreadContainerNode<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
	}

    @Override
    public RESULT visitSpecification(TBPSpecification<REFERENCE> node) {
		throw new RuntimeException("Unexpected type of node: " + node.getClass());
    }

}
