package org.ow2.dsrg.fm.tbplib.node.visitor;

import org.ow2.dsrg.fm.tbplib.node.*;

/**
 * Implementation of {@link TBPVisitor} that does nothing.
 * 
 * @author caitt3am
 *
 * @param <RESULT> Type returned by visit methods, if not overriden they will
 * return <code>null</code>.
 */
public class TBPDefaultVisitor<RESULT, REFERENCE> implements TBPVisitor<RESULT, REFERENCE> {

	@Override
	public RESULT visitParsedImperativeSequence(TBPImperativeSequence<REFERENCE> node) {
		return null;
	}

	@Override
	public RESULT visitVariableDefinition(TBPVariableDefinition<REFERENCE> node) {
		return null;
	}
	
	@Override
	public RESULT visitParsedSwitch(TBPSwitch<REFERENCE> node) {
		return null;
	}
	
	@Override
	public RESULT visitParsedIf(TBPIf<REFERENCE> node) {
		return null;
	}
	
	@Override
	public RESULT visitParsedValue(TBPValue<REFERENCE> node) {
		return null;
	}
	
	@Override
	public RESULT visitParsedReturn(TBPReturn<REFERENCE> node) {
		return null;
	}
	
	@Override
	public RESULT visitParsedWhile(TBPWhile<REFERENCE> node){
		return null;
	}
	
	@Override
	public RESULT visitParsedAssignment(TBPAssignment<REFERENCE> node){
		return null;
	}
	
	@Override
	public RESULT visitParsedMethodDeclaration(TBPMethodDeclaration<REFERENCE> node){
		return null;
	}
	
	@Override
	public RESULT visitParsedSync(TBPSync<REFERENCE> node){
		return null;
	}
        
        @Override
	public RESULT visitParsedWait(TBPWait<REFERENCE> node){
		return null;
	}
        
	
	@Override
	public RESULT visitParsedImperativeNull(TBPImperativeNull<REFERENCE> node){
		return null;
	}
	
	@Override
	public RESULT visitParsedEmit(TBPEmit<REFERENCE> node){
		return null;
	}
	
	@Override
	public RESULT visitParsedAlternative(TBPAlternative<REFERENCE> node) {
		return null;
	}
	
	@Override
	public RESULT visitParsedParallel(TBPParallel<REFERENCE>  node) {
		return null;
	}
	
	@Override
	public RESULT visitParsedParallelOr(TBPParallelOr<REFERENCE> node) {
		return null;
	}
	
	@Override
	public RESULT visitParsedSequence(TBPSequence<REFERENCE> node) {
		return null;
	}
	
	@Override
	public RESULT visitParsedAccept(TBPAccept<REFERENCE> node) {
		return null;
	}
	
	@Override
	public RESULT visitParsedNull(TBPProvisionNull<REFERENCE> node) {
		return null;
	}
	
	@Override
	public RESULT visitLimitedReentrancy(TBPLimitedReentrancy<REFERENCE> node) {
		return null;
	}
	
	@Override
	public RESULT visitParsedRepetition(TBPRepetition<REFERENCE> node) {
		return null;
	}
	
	@Override
	public RESULT visitUnlimitedReentrancy(TBPUnlimitedReentrancy<REFERENCE> node) {
		return null;
	}

	@Override
	public RESULT visitParsedProvisionContainerNode(
			TBPProvisionContainerNode<REFERENCE> parsedProvisionContainerNode) {
		return null;
	}

	@Override
	public RESULT visitParsedThreadContainerNode(TBPThreadContainerNode<REFERENCE> node) {
		return null;
	}

    @Override
    public RESULT visitSpecification(TBPSpecification<REFERENCE> node) {
		return null;
    }

}
