/*
 *
 * Threaded Behavior Protocols  - Parsers, Transformations
 * Copyright (C) 2008   DSRG, Charles University in Prague
 *                      http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */
package org.ow2.dsrg.fm.tbplib.node.visitor;

import org.ow2.dsrg.fm.tbplib.node.*;


public interface TBPVisitor<RESULT, REFERENCE> {

	RESULT visitParsedImperativeSequence(TBPImperativeSequence<REFERENCE> node);
	
    RESULT visitVariableDefinition(TBPVariableDefinition<REFERENCE> node);

    RESULT visitParsedSwitch(TBPSwitch<REFERENCE> node);
	RESULT visitParsedIf(TBPIf<REFERENCE> node);
	
	RESULT visitParsedValue(TBPValue<REFERENCE> node);
	RESULT visitParsedReturn(TBPReturn<REFERENCE> node);
	
	RESULT visitParsedWhile(TBPWhile<REFERENCE> node);
	
	RESULT visitParsedAssignment(TBPAssignment<REFERENCE> node);
	
	RESULT visitParsedMethodDeclaration(TBPMethodDeclaration<REFERENCE> node);
	
	RESULT visitParsedSync(TBPSync<REFERENCE> node);
        RESULT visitParsedWait(TBPWait<REFERENCE> node);
	
	
	RESULT visitParsedImperativeNull(TBPImperativeNull<REFERENCE> node);
	RESULT visitParsedEmit(TBPEmit<REFERENCE> node);
	
	RESULT visitParsedAlternative(TBPAlternative<REFERENCE> node);
	RESULT visitParsedParallel(TBPParallel<REFERENCE> node) ;
	RESULT visitParsedParallelOr(TBPParallelOr<REFERENCE> node);
	RESULT visitParsedSequence(TBPSequence<REFERENCE> node);
	
	RESULT visitParsedAccept(TBPAccept<REFERENCE> node) ;
	
	RESULT visitParsedNull(TBPProvisionNull<REFERENCE> node) ;
	
	RESULT visitLimitedReentrancy(TBPLimitedReentrancy<REFERENCE> node) ;
	RESULT visitParsedRepetition(TBPRepetition<REFERENCE> node) ;
	RESULT visitUnlimitedReentrancy(TBPUnlimitedReentrancy<REFERENCE> node) ;

	RESULT visitParsedProvisionContainerNode(
			TBPProvisionContainerNode<REFERENCE> node);

	RESULT visitParsedThreadContainerNode(TBPThreadContainerNode<REFERENCE> node);

    RESULT visitSpecification(TBPSpecification<REFERENCE> node);
}
