/*
 *  $Id$
 * 
 *   Threaded Behavior Protocols  - Parsers, Transformations
 *   Copyright (C) 2009       DSRG, Charles University in Prague
 *                            http://dsrg.mff.cuni.cz/
 * 
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 * 
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 * 
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *   MA 02110-1301 USA
 * 
 */

package org.ow2.dsrg.fm.tbplib.provision;

import org.ow2.dsrg.fm.tbplib.node.TBPProvisionNode;

/**
 * @author Ondrej Cerny &lt;ondrej.cerny@email.cz&gt;
 *
 */
public class MalformedProvisionException extends Error {
	private static final long serialVersionUID = 6485292994997802464L;
	
	private TBPProvisionNode<?> provision;
	
	public MalformedProvisionException() {
		super();
	}
	public MalformedProvisionException(String message) {
		super(message);
	}
	public MalformedProvisionException(String message, Throwable cause) {
		super(message, cause);
	}
	public MalformedProvisionException(String message, TBPProvisionNode<?> provision) {
		super(message);
		this.provision = provision;
	}
	public MalformedProvisionException(String message, Throwable cause, TBPProvisionNode<?> provision) {
		super(message, cause);
		this.provision = provision;
	}
	public TBPProvisionNode<?> getProvision() {
		return this.provision;
	}
}
