/*
 *  $Id$
 * 
 *   Threaded Behavior Protocols  - Parsers, Transformations
 *   Copyright (C) 2010       DSRG, Charles University in Prague
 *                            http://dsrg.mff.cuni.cz/
 * 
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 * 
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 * 
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *   MA 02110-1301 USA
 * 
 */

package org.ow2.dsrg.fm.tbplib.provision;

/**
 * @author Ondrej Cerny &lt;ondrej.cerny@email.cz&gt;
 *
 */
public interface ObservingProvisionAutomaton<OUTPUTSYMBOL> extends
		ProvisionAutomaton<OUTPUTSYMBOL> {
	
    /**
     * Does the automaton observe this event?
     *
     * @param event encoding of an event
     * @return <code>true</code> if the given event is observed by this
     *      , <code>false</code> when this object ignores the event.
     */
    boolean observesEvent(long event);
    
    /**
     * Does the automaton observe events associated with the given method?
     *
     * @param method integer encoding of the method
     * @return <code>true</code> if the given event is observed by this
     *      observer, <code>false</code> when the observer ignores the event.
     */
    boolean observesMethod(int method);
}
