/*
 *  $Id$
 * 
 *   Threaded Behavior Protocols  - Parsers, Transformations
 *   Copyright (C) 2009       DSRG, Charles University in Prague
 *                            http://dsrg.mff.cuni.cz/
 * 
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 * 
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 * 
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *   MA 02110-1301 USA
 * 
 */
package org.ow2.dsrg.fm.tbplib.provision.actuator;

import org.ow2.dsrg.fm.tbplib.ltsa.LTS;
import org.ow2.dsrg.fm.tbplib.node.TBPNode;
import org.ow2.dsrg.fm.tbplib.provision.actuator.visitor.ActionSeqNodeVisitor;

/** Node of action sequence.
 * 
 * <p> Represents sequence of actions.
 * </p>
 * 
 * @author Ondrej Cerny &lt;ondrej.cerny@email.cz&gt;
 *
 */
public interface ActionSeqNode<REFERENCE> {
		
	/** Returns successor of this.
	 * 
	 * @return {@link ActionSeqNode}
	 */
	public ActionSeqNode<REFERENCE> getSuccessor();
	/** Sets successors of this.
	 * 
	 * @param newValue {@link ActionSeqNode}
	 */
	public void setSuccessor(ActionSeqNode<REFERENCE> newValue);
	
	public LTS<? extends TBPNode<REFERENCE>, REFERENCE> getInitialLTSTransition();
	
	public void setInitialLTSTransition(LTS<? extends TBPNode<REFERENCE>, REFERENCE> transition);
	
	public<RESULT> RESULT visit(ActionSeqNodeVisitor<RESULT, REFERENCE> visitor); 
	
	
}
