/*
 *  $Id$
 * 
 *   Threaded Behavior Protocols  - Parsers, Transformations
 *   Copyright (C) 2009       DSRG, Charles University in Prague
 *                            http://dsrg.mff.cuni.cz/
 * 
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 * 
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 * 
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *   MA 02110-1301 USA
 * 
 */

package org.ow2.dsrg.fm.tbplib.provision.actuator;

import org.ow2.dsrg.fm.tbplib.node.TBPEmit;
import org.ow2.dsrg.fm.tbplib.provision.actuator.visitor.ActionSeqNodeVisitor;

/**
 * @author Ondrej Cerny &lt;ondrej.cerny@email.cz&gt;
 *
 */
public class EmitEventAction<REFERENCE> extends ActionSeqNodeImpl<REFERENCE> {
	
	private TBPEmit<REFERENCE> emit;
	private REFERENCE expectedReturnValue;
	
	public EmitEventAction() {
	}
	public EmitEventAction(TBPEmit<REFERENCE> emit, REFERENCE expectedReturnValue) {
		this();
		this.emit = emit;
		this.expectedReturnValue = expectedReturnValue;
	}
	
	
	public void setEmit(TBPEmit<REFERENCE> newValue) {
		this.emit = newValue;
	}
	public TBPEmit<REFERENCE> getEmit() {
		return this.emit;
	}
	
	public void setExpectedReturnValue(REFERENCE newValue) {
		this.expectedReturnValue = newValue;
	}
	public REFERENCE getExpectedReturnValue() { 
		return this.expectedReturnValue;
	}
	
	
	@Override
	public <RESULT> RESULT visit(ActionSeqNodeVisitor<RESULT, REFERENCE> visitor) {
		return visitor.visitEmitEventAction(this);
	}
}
