/*
 *  $Id$
 * 
 *   Threaded Behavior Protocols  - Parsers, Transformations
 *   Copyright (C) 2009       DSRG, Charles University in Prague
 *                            http://dsrg.mff.cuni.cz/
 * 
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 * 
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 * 
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *   MA 02110-1301 USA
 * 
 */

package org.ow2.dsrg.fm.tbplib.provision.actuator.visitor;

import java.util.Collection;
import java.util.LinkedList;
import java.util.List;

import org.ow2.dsrg.fm.tbplib.ltsa.LTSA;

/**
 * @author Ondrej Cerny &lt;ondrej.cerny@email.cz&gt;
 */
public class LTSAHandler <CODE_REFERENCE, REFERENCE> {
	private List<LTSA<CODE_REFERENCE, REFERENCE>> entryPoints;
	private List<LTSA<CODE_REFERENCE, REFERENCE>> endPoints;
	private int copies;
	
	public LTSAHandler() {
		entryPoints = new LinkedList<LTSA<CODE_REFERENCE, REFERENCE>>();
		endPoints = new LinkedList<LTSA<CODE_REFERENCE, REFERENCE>>();
		copies = 1;
	}
	
	public List<LTSA<CODE_REFERENCE, REFERENCE>> getEntryPoints() {
		return entryPoints;
	}
	public void addEntryPoints(Collection<LTSA<CODE_REFERENCE, REFERENCE>> values) {
		this.entryPoints.addAll(values);
	}
	public void addEntryPoint(LTSA<CODE_REFERENCE, REFERENCE> value) {
		this.entryPoints.add(value);
	}
	public void clearEntryPoints() {
		this.entryPoints.clear();
	}
	public List<LTSA<CODE_REFERENCE, REFERENCE>> getEndPoints() {
		return endPoints;
	}
	public void addEndPoints(Collection<LTSA<CODE_REFERENCE, REFERENCE>> values) {
		this.endPoints.addAll(values);
	}
	public void addEndPoint(LTSA<CODE_REFERENCE, REFERENCE> value) {
		this.endPoints.add(value);
	}
	public void clearEndPoints() {
		this.endPoints.clear();
	}
	public void setCopies(int copies) {
		this.copies = copies;
	}
	public int getCopies() {
		return this.copies;
	}
}
