/*
 *  $Id$
 * 
 *   Threaded Behavior Protocols  - Parsers, Transformations
 *   Copyright (C) 2009       DSRG, Charles University in Prague
 *                            http://dsrg.mff.cuni.cz/
 * 
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 * 
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 * 
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *   MA 02110-1301 USA
 * 
 */

package org.ow2.dsrg.fm.tbplib.provision.actuator.visitor;

import java.util.Collection;
import java.util.LinkedList;
import java.util.List;

import org.ow2.dsrg.fm.tbplib.ltsa.LTS;
import org.ow2.dsrg.fm.tbplib.node.TBPNode;

/**
 * @author Ondrej Cerny &lt;ondrej.cerny@email.cz&gt;
 * @deprecated Replaced by {@link LTSAHandler}
 */
class LTSHandler<REFERENCE> {
	private List<LTS<? extends TBPNode<REFERENCE>, REFERENCE>> entryPoints;
	private List<LTS<? extends TBPNode<REFERENCE>, REFERENCE>> endPoints;
	
	public LTSHandler() {
		entryPoints = new LinkedList<LTS<? extends TBPNode<REFERENCE>,REFERENCE>>();
		endPoints = new LinkedList<LTS<? extends TBPNode<REFERENCE>,REFERENCE>>();
	}
	
	public List<LTS<? extends TBPNode<REFERENCE>, REFERENCE>> getEntryPoints() {
		return entryPoints;
	}
	public void addEntryPoints(Collection<LTS<? extends TBPNode<REFERENCE>, REFERENCE>> values) {
		this.entryPoints.addAll(values);
	}
	public void addEntryPoint(LTS<? extends TBPNode<REFERENCE>, REFERENCE> value) {
		this.entryPoints.add(value);
	}
	public void clearEntryPoints() {
		this.entryPoints.clear();
	}
	public List<LTS<? extends TBPNode<REFERENCE>, REFERENCE>> getEndPoints() {
		return endPoints;
	}
	public void addEndPoints(Collection<LTS<? extends TBPNode<REFERENCE>, REFERENCE>> values) {
		this.endPoints.addAll(values);
	}
	public void addEndPoint(LTS<? extends TBPNode<REFERENCE>, REFERENCE> value) {
		this.endPoints.add(value);
	}
	public void clearEndPoints() {
		this.endPoints.clear();
	}
}
